/* Copyright 2005 Jetro Lauha - http://iki.fi/jetro/
 *
 * $Id: Levels.cpp,v 1.6 2005/04/19 18:17:47 tonic Exp $
 * $Revision: 1.6 $
 */

#include "main.h"


#define LEVEL_COUNT     70


static INT sLevelLightGoals[LEVEL_COUNT] =
{
    10, 20, 30, 10, 40,    50, 15, 35, 10, 0,
    20, 30, 40, 20, 50,    60, 20, 40, 15, 0,
    20, 30, 40, 20, 50,    60, 20, 45, 15, 0,
    30, 40, 50, 30, 60,    70, 30, 50, 20, 10,
    40, 50, 60, 40, 70,    80, 40, 60, 30, 20,
    50, 60, 70, 50, 80,    90, 50, 70, 40, 30,
    60, 70, 80, 60, 90,    100, 60, 80, 50, 40,
};
static INT sLevelAccuracyGoals[LEVEL_COUNT] =
{
    0, 0, 10, 0, 10,       10, 0, 0, 50, 75,
    20, 20, 25, 10, 20,    25, 10, 10, 75, 100,
    20, 20, 25, 10, 20,    25, 10, 10, 75, 100,
    40, 40, 45, 20, 40,    35, 20, 20, 80, 100,
    50, 50, 55, 30, 50,    45, 30, 30, 90, 100,
    60, 60, 65, 40, 60,    55, 40, 40, 94, 100,
    70, 70, 75, 50, 70,    65, 50, 50, 98, 100,
};


void Levels::resetGame()
{
    mCurrentLevel = 1;
    mLevelPassed = FALSE;
    mScore = 0;
}


void Levels::advanceToNextLevel()
{
    ++mCurrentLevel;
    startLevel();
}


void Levels::startLevel()
{
    BOOL success = FALSE;
#define LEVEL(speed, mapfile, tilefile) do {\
        success = mGameState->loadMap(DATA_PREFIX mapfile, DATA_PREFIX tilefile);\
        mGameState->startLevel(speed); } while(0)

    switch (mCurrentLevel)
    {
    case 1: LEVEL(0.05f, "map1.MAP", "tiles0.png"); break;
    case 2: LEVEL(0.06f, "map2.MAP", "tiles0.png"); break;
    case 3: LEVEL(0.07f, "map3.MAP", "tiles0.png"); break;
    case 4: LEVEL(0.25f, "map2.MAP", "tiles0.png"); break;  // low goal, fast
    case 5: LEVEL(0.07f, "map4.MAP", "tiles0.png"); break;
    case 6: LEVEL(0.08f, "map5.MAP", "tiles0.png"); break;
    case 7: LEVEL(0.21f, "map3.MAP", "tiles0.png"); break;  // low goal, fast
    case 8: LEVEL(0.11f, "map5.MAP", "tiles0.png"); break;  // moderate speed, hi goal
    case 9: LEVEL(0.25f, "map4.MAP", "tiles0.png"); break;  // fast, low goal, med accuracy
    case 10: LEVEL(0.25f, "map3.MAP", "tiles0.png"); break;  // fast, no goal, hi accuracy

    case 11: LEVEL(0.06f, "map1.MAP", "tiles0.png"); break;
    case 12: LEVEL(0.07f, "map2.MAP", "tiles0.png"); break;
    case 13: LEVEL(0.08f, "map3.MAP", "tiles0.png"); break;
    case 14: LEVEL(0.26f, "map2.MAP", "tiles0.png"); break;  // low goal, fast
    case 15: LEVEL(0.08f, "map4.MAP", "tiles0.png"); break;
    case 16: LEVEL(0.09f, "map5.MAP", "tiles0.png"); break;
    case 17: LEVEL(0.22f, "map3.MAP", "tiles0.png"); break;  // low goal, fast
    case 18: LEVEL(0.13f, "map5.MAP", "tiles0.png"); break;  // moderate speed, hi goal
    case 19: LEVEL(0.26f, "map4.MAP", "tiles0.png"); break;  // fast, low goal, hi accuracy
    case 20: LEVEL(0.26f, "map3.MAP", "tiles0.png"); break;  // fast, no goal, 100% accuracy

    case 21: LEVEL(0.08f, "map1.MAP", "tiles0.png"); break;
    case 22: LEVEL(0.09f, "map2.MAP", "tiles0.png"); break;
    case 23: LEVEL(0.10f, "map3.MAP", "tiles0.png"); break;
    case 24: LEVEL(0.27f, "map2.MAP", "tiles0.png"); break;  // low goal, fast
    case 25: LEVEL(0.10f, "map4.MAP", "tiles0.png"); break;
    case 26: LEVEL(0.11f, "map5.MAP", "tiles0.png"); break;
    case 27: LEVEL(0.23f, "map3.MAP", "tiles0.png"); break;  // low goal, fast
    case 28: LEVEL(0.15f, "map5.MAP", "tiles0.png"); break;  // moderate speed, hi goal
    case 29: LEVEL(0.27f, "map4.MAP", "tiles0.png"); break;  // fast, low goal, hi accuracy
    case 30: LEVEL(0.27f, "map3.MAP", "tiles0.png"); break;  // fast, no goal, 100% accuracy

    case 31: LEVEL(0.08f, "map1.MAP", "tiles0.png"); break;
    case 32: LEVEL(0.09f, "map2.MAP", "tiles0.png"); break;
    case 33: LEVEL(0.10f, "map3.MAP", "tiles0.png"); break;
    case 34: LEVEL(0.27f, "map2.MAP", "tiles0.png"); break;  // low goal, fast
    case 35: LEVEL(0.10f, "map4.MAP", "tiles0.png"); break;
    case 36: LEVEL(0.11f, "map5.MAP", "tiles0.png"); break;
    case 37: LEVEL(0.23f, "map3.MAP", "tiles0.png"); break;  // low goal, fast
    case 38: LEVEL(0.16f, "map5.MAP", "tiles0.png"); break;  // moderate speed, hi goal
    case 39: LEVEL(0.27f, "map4.MAP", "tiles0.png"); break;  // fast, low goal, hi accuracy
    case 40: LEVEL(0.27f, "map3.MAP", "tiles0.png"); break;  // fast, low goal, 100% accuracy

    case 41: LEVEL(0.16f, "map1.MAP", "tiles0.png"); break;
    case 42: LEVEL(0.18f, "map2.MAP", "tiles0.png"); break;
    case 43: LEVEL(0.20f, "map3.MAP", "tiles0.png"); break;
    case 44: LEVEL(0.37f, "map2.MAP", "tiles0.png"); break;  // low goal, fast
    case 45: LEVEL(0.20f, "map4.MAP", "tiles0.png"); break;
    case 46: LEVEL(0.22f, "map5.MAP", "tiles0.png"); break;
    case 47: LEVEL(0.33f, "map3.MAP", "tiles0.png"); break;  // low goal, fast
    case 48: LEVEL(0.26f, "map5.MAP", "tiles0.png"); break;  // moderate speed, hi goal
    case 49: LEVEL(0.37f, "map4.MAP", "tiles0.png"); break;  // fast, low goal, hi accuracy
    case 50: LEVEL(0.37f, "map3.MAP", "tiles0.png"); break;  // fast, low goal, 100% accuracy

    case 51: LEVEL(0.26f, "map1.MAP", "tiles0.png"); break;
    case 52: LEVEL(0.28f, "map2.MAP", "tiles0.png"); break;
    case 53: LEVEL(0.30f, "map3.MAP", "tiles0.png"); break;
    case 54: LEVEL(0.47f, "map2.MAP", "tiles0.png"); break;  // low goal, fast
    case 55: LEVEL(0.30f, "map4.MAP", "tiles0.png"); break;
    case 56: LEVEL(0.32f, "map5.MAP", "tiles0.png"); break;
    case 57: LEVEL(0.43f, "map3.MAP", "tiles0.png"); break;  // low goal, fast
    case 58: LEVEL(0.36f, "map5.MAP", "tiles0.png"); break;  // moderate speed, hi goal
    case 59: LEVEL(0.47f, "map4.MAP", "tiles0.png"); break;  // fast, low goal, hi accuracy
    case 60: LEVEL(0.47f, "map3.MAP", "tiles0.png"); break;  // fast, low goal, 100% accuracy

    case 61: LEVEL(0.36f, "map1.MAP", "tiles0.png"); break;
    case 62: LEVEL(0.38f, "map2.MAP", "tiles0.png"); break;
    case 63: LEVEL(0.40f, "map3.MAP", "tiles0.png"); break;
    case 64: LEVEL(0.57f, "map2.MAP", "tiles0.png"); break;  // low goal, fast
    case 65: LEVEL(0.40f, "map4.MAP", "tiles0.png"); break;
    case 66: LEVEL(0.42f, "map5.MAP", "tiles0.png"); break;
    case 67: LEVEL(0.53f, "map3.MAP", "tiles0.png"); break;  // low goal, fast
    case 68: LEVEL(0.46f, "map5.MAP", "tiles0.png"); break;  // moderate speed, hi goal
    case 69: LEVEL(0.57f, "map4.MAP", "tiles0.png"); break;  // fast, low goal, hi accuracy
    case 70: LEVEL(0.57f, "map3.MAP", "tiles0.png"); break;  // fast, low goal, 100% accuracy
    }

    // NOTE: There is nothing to be done if user manages to play
    //       through all levels -- should add game end or victory condition
    //       here for that case. (However it is probably quite impossible
    //       to play that far with the current level settings.)

    if (!success)
        errorMessage("Error", "Problems starting level, sorry!");
    mLevelPassed = FALSE;
    setMusic(TRUE, MUSIC_INGAME);
}


void Levels::notifyLevelFinished()
{
    mLevelPassed = TRUE;
    mLightCount = mGameState->getLevelLightCount();
    mLightsKilled = mGameState->getLightsKilled();
    mBulletsShot = mGameState->getBulletsShot();
    if (mBulletsShot > 0)
        mAccuracy = 10000 * mLightsKilled / mBulletsShot;
    else
        mAccuracy = 0;
    INT32 lightGoal = sLevelLightGoals[mCurrentLevel - 1];
    INT32 accuracyGoal = sLevelAccuracyGoals[mCurrentLevel - 1];
    lightGoal = (lightGoal * mLightCount) / 100;
    if (lightGoal > 0 && mLightsKilled < lightGoal)
        mLevelPassed = FALSE;
    if (accuracyGoal > 0 && mAccuracy < accuracyGoal * 100)
        mLevelPassed = FALSE;
    if (mLevelPassed)
        setMusic(TRUE, MUSIC_VICTORY);
    else
        setMusic(TRUE, MUSIC_FAILURE);
}


void Levels::handleContinue()
{
    GameApp *ga = GameApp::getInstance();

    if (mLevelPassed)
        advanceToNextLevel();
    else
    {
        INT32 bestScore = ga->getBestScore();
        if (mScore > bestScore)
        {
            bestScore = mScore;
            ga->setBestScore(bestScore);
        }

        GameApp::getInstance()->setState(GameApp::STATE_TITLE);
    }
}


void Levels::renderScore()
{
    GameApp *ga = GameApp::getInstance();
    UIFont *medium = ga->getMediumFont();
    char tmp[512];

    sprintf(tmp, "%d", mScore);
    medium->drawString(0, 0, 0, tmp);
}


void Levels::renderStartText()
{
    GameApp *ga = GameApp::getInstance();
    //UIFont *small = ga->getSmallFont();
    UIFont *medium = ga->getMediumFont();
    UIFont *big = ga->getBigFont();
    char tmp[512];
    FLOAT y = HEIGHT / 3, gap = 8;

    sprintf(tmp, "LEVEL %d", mCurrentLevel);
    big->drawString(WIDTH / 2, y, UIFont::ALIGN_HORIZ_CENTER | UIFont::ALIGN_BOTTOM, tmp);
    y += gap;

    INT32 lightCount = mGameState->getLevelLightCount();
    sprintf(tmp, "%d lights", lightCount);
    medium->drawString(WIDTH / 2, y, UIFont::ALIGN_HORIZ_CENTER, tmp, 1, 1, 0.5f, 1);
    y += medium->getFontHeight() + gap * 3;

    INT32 lightGoal = sLevelLightGoals[mCurrentLevel - 1];
    INT32 accuracyGoal = sLevelAccuracyGoals[mCurrentLevel - 1];
    lightGoal = (lightGoal * lightCount) / 100;
    if (lightGoal || accuracyGoal)
    {
        medium->drawString(WIDTH / 2, y, UIFont::ALIGN_HORIZ_CENTER, "GOALS:");
        y += medium->getFontHeight() + gap;
    }

    if (lightGoal > 0)
    {
        sprintf(tmp, "Shoot %d lights", lightGoal);
        medium->drawString(WIDTH / 2, y, UIFont::ALIGN_HORIZ_CENTER, tmp, 1, 0.8f, 0.6f, 1);
        y += medium->getFontHeight() + gap;
    }
    if (accuracyGoal > 0)
    {
        sprintf(tmp, "Accuracy %d%%", accuracyGoal);
        medium->drawString(WIDTH / 2, y, UIFont::ALIGN_HORIZ_CENTER, tmp, 1, 0.8f, 0.6f, 1);
        y += medium->getFontHeight() + gap;
    }

    switch (mCurrentLevel)
    {
    case 1:
        medium->drawString(WIDTH / 2, HEIGHT * 2 / 3,
                           UIFont::ALIGN_HORIZ_CENTER,
                           "Shoot at the lights!");
        break;
    }
}


void Levels::renderFinishedText()
{
    GameApp *ga = GameApp::getInstance();
    //UIFont *small = ga->getSmallFont();
    UIFont *medium = ga->getMediumFont();
    UIFont *big = ga->getBigFont();
    char tmp[512];
    FLOAT y = HEIGHT / 3, gap = 8;

    if (mLevelPassed)
        big->drawString(WIDTH / 2, y, UIFont::ALIGN_HORIZ_CENTER | UIFont::ALIGN_BOTTOM,
                        "Well Done!", 0.8f, 1, 0.8f, 1);
    else
        big->drawString(WIDTH / 2, y, UIFont::ALIGN_HORIZ_CENTER | UIFont::ALIGN_BOTTOM,
                        "You Failed!", 1, 0.5f, 0.5f, 1);
    y += gap * 2;

    INT32 lightGoal = sLevelLightGoals[mCurrentLevel - 1];
    INT32 accuracyGoal = sLevelAccuracyGoals[mCurrentLevel - 1];
    lightGoal = (lightGoal * mLightCount) / 100;

    if (lightGoal > 0)
        sprintf(tmp, "You got %d of %d lights (min. %d)",
                mLightsKilled, mLightCount, lightGoal);
    else
        sprintf(tmp, "You got %d of %d lights", mLightsKilled, mLightCount);
    medium->drawString(WIDTH / 2, y, UIFont::ALIGN_HORIZ_CENTER, tmp);
    y += medium->getFontHeight() + gap;

    if (accuracyGoal > 0)
        sprintf(tmp, "Accuracy %02d.%02d%% (min. %d%%)",
                mAccuracy / 100, mAccuracy % 100, accuracyGoal);
    else
        sprintf(tmp, "Accuracy %02d.%02d%%", mAccuracy / 100, mAccuracy % 100);
    medium->drawString(WIDTH / 2, y, UIFont::ALIGN_HORIZ_CENTER, tmp);
    y += medium->getFontHeight() + gap;
}
