/* Copyright 2005 Jetro Lauha - http://iki.fi/jetro/
 *
 * $Id: Levels.h,v 1.2 2005/04/17 16:39:02 tonic Exp $
 * $Revision: 1.2 $
 */

#ifndef LEVELS_H_INCL
#define LEVELS_H_INCL


class GameState;


class Levels
{
public:

    Levels() : mGameState(NULL) { resetGame(); }

    void init(GameState *gs) { mGameState = gs; }

    void resetGame();

    void advanceToNextLevel();
    void startLevel();
    void notifyLevelFinished();

    void handleContinue();

    void renderScore();
    void renderStartText();
    void renderFinishedText();

    void addScore(INT32 score) { mScore += score; }
    INT32 getCurrentLevel() { return mCurrentLevel; }

protected:

    GameState *mGameState;

    INT32 mCurrentLevel;
    BOOL mLevelPassed;

    // Cached stats when level is finished:
    INT32 mLightCount, mLightsKilled, mBulletsShot;
    INT32 mAccuracy;    // scaled by 10000
    INT32 mScore;
};


#endif // !LEVELS_H_INCL
