/* Copyright 2005 Jetro Lauha - http://iki.fi/jetro/
 *
 * $Id: ParticleSystem.h,v 1.1 2005/04/17 16:39:18 tonic Exp $
 * $Revision: 1.1 $
 */

#ifndef PARTICLESYSTEM_H_INCL
#define PARTICLESYSTEM_H_INCL


class ParticleSystem
{
public:

    ParticleSystem();
    ~ParticleSystem();

    BOOL init();

    void spawn(FLOAT x, FLOAT y, FLOAT xi, FLOAT yi);
    void update();
    void render();

protected:

    struct Particle
    {
        FLOAT x, y;
        FLOAT xi, yi;
        INT32 age;
        FLOAT color[4];
    };

    typedef std::list<Particle *> ParticleList;
    ParticleList mParticles;

    UIImage *mParticleImage;
};


#endif // !PARTICLESYSTEM_H_INCL
