/* Copyright 2005 Jetro Lauha - http://iki.fi/jetro/
 *
 * $Id: State.h,v 1.1 2005/04/17 10:49:27 tonic Exp $
 * $Revision: 1.1 $
 */

#ifndef STATE_H_INCL
#define STATE_H_INCL


class State
{
public:

    State() : mFPS(60) {}
    virtual ~State() {}

    virtual BOOL init() { return TRUE; }
    virtual void deinit() {}

    UINT32 getUpdateFPS() { return mFPS; }

    virtual BOOL update(UINT32 time) = 0;
    virtual void render(SDL_Surface *screen) = 0;

    virtual void onActivate(UINT32 /*time*/) {}
    virtual void onDeactivate() {}

    virtual void onKeyDown(const SDLKey &key) {}
    virtual void onKeyUp(const SDLKey &key) {}
    virtual void onMouseDown(const SDL_MouseButtonEvent &event) {}
    virtual void onMouseUp(const SDL_MouseButtonEvent &event) {}
    virtual void onMouseMotion(const SDL_MouseMotionEvent &event) {}

protected:

    UINT32 mFPS;
};


#endif // !STATE_H_INCL
